#pragma once
#ifndef _GN_H_
#define _GN_H_

#define GN_INTERFACE_VERSION "2.2"  // ӿڰ汾

#define GN_VERSION "2023.5.20"      // 汾

/*------------------------------------------------ !! GN SDKʹ !! ----------------------------------------------------------\
|                                                                                                                                     |
|	SDKǸ,,,ļ,Ҫ,Żλ,ʵʱ3D                                                 |
|	һЩģ鶨о˵ǰ汾еĴ¹, SDK޸Щ, ͷļĳֵҲҪ޸                 |
|	ʹñӦʱʾ35LOGO, һȷʹ, ʾͬ!!                            |
|                                                                                                                                     |
|	Ҫ: OpenGL. GLEW.  OpengAL(ʹŵĻ)  Fbx SDK(ʹõ3ds dae dxfЩļʽĻ)  |
|	(ѡ)ҪƵ, Ҫõ FFmpeg.                                                                                      |
|	ʹù, ϣչӿڿԼ QQȺ288089884 ṩ, ˽ʹӻϸĵԵ½:              |
|	www.gncreate.com  www.img-power.com !                                                                                       |
|	                                                                                                                                  |
\------------------------------------------------------------------------------------------------------------------------------------*/

/* ڱ뻷ԤһȷӦģʽ */
//#define GN_USING_SDK                       //SDKʽʹ
//#define GN_USING_SDK_INTEGRATION           //һ廯SDKʽʹ
//#define GN_USING_LIB_EXPORTS               //̬⵼
//#define GN_USING_SOURCE_CODE               //Դ༭

/* DEBUGģʽ     һĿȽϷ */
//#define GN_DEBUG


// #ǶģϢ ----------------------------------------------------------------------------------------------------------

/* Ƕʹ2Dģ: - ǰ̨Ӧñ */
#define GN_USING_2D 2

/* Ƕʹ3Dģ */
#define GN_USING_3D 4

/* ǶʹƵģ */
#define GN_USING_AUDIO 8

/* Ƕʹģ: - ̨ */
#define GN_USING_NET 16

/* Ƕʹzipѹģ */
#define GN_USING_UNZIP 32

/* Ƕʹøģ */
#define GN_USING_UPDATE 64

/* Ƕʵùģ */
#define GN_USING_UTILITY_LIB 1

/* Ƕ⸽ӹģ */
#define GN_USING_ADDITIONAL_LIB 256

/* Ƕָ֧ⲿ3Dļʽ ѡĿǰ֧Windowsϵͳ */
#define GN_USING_EXT_3DFILE_FORMAT 512

/* Ƕ֧ASERTX 3Dļʽ ϰ汾3DMAXһֵʽ */ 
//#define GN_USING_ASE_3DFILE_FORMAT 1024 

/* Ƕרʽg3dļ湦ģ */
#define GN_USING_G3D_FORMAT_SAVE 2048


//#ʹûĴС ---------------------------------------------------------------------------------------------------------

/* ʹ ļ С  2MB */
#define GN_USING_FILE_BUF 2097152

/* ֧̲߳ */
#define GN_USING_PARALLEL_MAX  32


/* 3Dģʹó ָ֧ */
//#define GN_USING_TRI_LONG_INDEX 1024

//---------------------------------------------------------------------------------------------------------------------------------
#ifndef GN_USING_UTILITY_LIB
#undef  GN_VERSION
#define GN_VERSION "0.0"
#endif
#if defined GN_USING_UPDATE && !defined GN_USING_UNZIP
 #define GN_USING_UNZIP 32  //ģõѹģ
#endif
#define GN_RUNTSTART(nc)                                     0
#define GN_RUNTEND(time_proc)                                0
#define GN_RUNTENDMF()										 0
#define GN_RunReportError()                                  0
#define GN_RunTextOut(text,count,x,y,w,h,color,blendmode)    0
#define GN_RunDrawFrame(x,y,w,h,color)						 0
#define GN_RunValueCheck(value,name,ID_order)                0
#define GN_RunValueCheck2(value,ID_order)                    0
#define GN_RunProgressSizeGet(out_w,out_h)					 0
#define GN_RunProgressDraw(progress,style,re_draw,cx,cy,icon_color,text_color,frame_color,bar_color,blendmode) 0
#define GN_RunKCOF(vname,KCODE,ID_order)                     0
#define GN_RunKCV (type,vname,vdef,vadd,KADD,KSUB,ID_order)  0
#define GN_RunKCV1(type,vname,vdef,vadd,KADD,KSUB,ID_order)  0

#include"_SysDef/GN_SysDef.h"  //Ŀϵͳƽ̨, ĿϵͳõһЩͷļͶһЩڲͬϵͳõʶϵͳĺ

#ifndef _WIN32_
#undef GN_USING_EXT_3DFILE_FORMAT
#endif
typedef void (*GT_VOID_PFUNC_UINT)(unsigned int);
typedef void (*GT_PFUNC_VOID)(void);
typedef void (*GT_PFUNC_PVOID)(void*);
typedef void (*GT_PFUNC_PVOID_PVOID)(void*, void*);
typedef void (*GT_PFUNC_PVOID_UINT3)(void *, unsigned int, unsigned int, unsigned int);

typedef bool (*GT_BOOL_PFUNC_PVOID)(void*);

typedef signed char          int8;
typedef signed long long     int64;
typedef unsigned char        uint8;
typedef unsigned long long   uint64;

extern GN_API unsigned long  GT_SystemInited;   //ϵͳǷѾʼ

//ͷļģ鹦ܺϵṹ ÿͷļڸļĵط 
//_Ŀ¼ڵͷļΪӿתģ ʵļӦͬϵͳƽ̨вͬĴ ȷĽӿͳһ ʹܹڲͬƽ̨

// ͨù
#include"GN_Base.h"                    //һЩȽϻõĹ  Բֵ ֵϵȽϵ
#include"GN_Array.h"				   //ݽṹ ݽṹ ȫָ ڴغȽϵȹ
 #include"GN_String.h"				   //ַļ·ȹ
 #include"_Sys/GN_Sys.h"               //ϵͳļIO ϵͳ ϵͳĿ¼ ַת ߳ ʱ С貿IO ת
  #include"GN_Parallel.h"			   //߳ мȹ
  #include"GN_File.h"                  //ļ Դȡ ־ļ ߳
   #include"GN_Format.h"               //øʽļ뱣 ɫʽת ѹѹļȴ
     
// 
#ifdef GN_USING_AUDIO
#include"_Sound/GN_Sound.h"            //ŲɼƵݵĵײת
   #ifdef GN_USING_UTILITY_LIB
    #include"GN_Audio.h"               //ֿ ŵȹ Ƚʵõһģ
   #endif 
#endif

// 2D
#ifdef GN_USING_2D
#include"GN_Color.h"				   //ɫ ɫת
#include"GN_Layout.h"				   //ƽλò ʽŰ ȹ
#include"GN_2Dmath.h"                  //2Dͼδõļѧȹ
 #include"GN_Linear.h"				   //Բֵֵ߲ȹ
 #include"GN_2DArea.h"				   //2Dռ2Dײȹ
    #include"GN_2Dtype.h"              //2DͼδõһЩݽṹ ܱ־
     #include"_Graphics/GN_G2D.h"      //2DͼεĻƺ֡ݶȡת
      #include"GN_2D.h"                //2Dͼλ ߻ Ļͼ ͼĻ лͼ
       #include"GN_Input.h"            //ϸּ   ¼ͻط ݼʱ Ƚʵõһģ
        #include "GN_Init.h"           // Զ д޸һЩϵͳʼ iniļ ûʹ
         #include"_Main/GN_Main.h"     //ϵͳƽ̨ڵת ͼڵĴ ѭʹܲͣе ģҪΪϵͳƽ̨֮һ
      #ifdef GN_USING_UTILITY_LIB
        #include"GN_InputAct.h"        //붯Ӧ
       #include"GN_Font.h"             //ͼģʽ¸ʾƯֵĹ
         #include"GN_RunRec.h"         //м¼Ϣ з֧ еıֵ ͳƴʱ 
 #include"GN_AmCtrl.h"				   //ʱ䲥ſƹ
        #include"GN_Frame.h"		   //2Dֵflash 2DЧ ֶ̬ Ƚʵõһģ
		 #include"GN_UiBase.h"         //ûһЩԪ
		 #include"GN_UiTextIn.h"	   //ûıԪ
		 #include"GN_UiFBrowser.h"	   //ûļԪ
          #include"GN_UiPopDlg.h"	   //ûĵѡԪ
           #include"GN_UI.h"           //ûصĹ   !д
      #endif
#endif

// 3Dܶ !Ͼͼ豸ָ2011ǰ豸
#ifdef GN_USING_3D
  #include"GN_3Dmath.h"                //3Dͼδõļѧ ֵ߲ȹ
   #include"GN_3DArea.h"			   //3Dռײȹ
    #include"GN_3Dtype.h"              //3DͼδõһЩݽṹ ܱ־
	 #include"GN_3DMesh.h"			   //3D ɵȹ
      #include"_Graphics/GN_G3D.h"     //3DȾ Ⱦ ȾģʽЧл ȹ ȽҪһģ
      #ifdef GN_USING_UTILITY_LIB
     #include"GN_3DAmKey.h"			   //3Dؼ㴴 ֵȹ
     #include"GN_3DMeshEdit.h"         //3D༭һЩ
       #include"GN_3D.h"               //3DռĶ ģ ƹ  Ͳǵıݹܷ Ƚʵõһģ
        #include"GN_3Dscene.h"         //ʵ3DȡʾйƵ๦ 3Dļ2ƶд Ƚʵõһģ
      #endif
#endif

// 繦
#ifdef GN_USING_NET
 #include"GN_NetBase.h"                //ͨѶһЩ
#include"_Net/GN_Net.h"                //ͨѶĵײת
  #ifdef GN_USING_UTILITY_LIB
   #include"GN_NetTrans.h"             //紫һЩʵù ͨѶ httpЭͨѶ ļ 첽 Ƚʵõһģ
    #ifdef GN_USING_ADDITIONAL_LIB
    #include"GN_NetFile.h"             //ʵ÷ʱļͬķļ 
    #endif
  #endif
#else
 #ifndef GN_USING_ADDITIONAL_LIB
  //ȾҪģ
  #define NET_USING_INDEPENDENT
  #include<GN_NetBase.h>
 #endif
#endif

#if !defined(GN_USING_SOURCE_CODE) && !defined(GN_USING_LIB_EXPORTS)
#pragma comment(lib,"GNwin32.LIB")
#endif

GN_API char *const GN_GetInterfaceVersion();   //ӿڰ汾

GN_API char *const GN_GetVersion();            //汾

GN_API unsigned long GN_GetModuleConstitute(); //йģ һģ鹹ɱλ
                                               //жϰģ if(GN_GetModuleConstitute() & GN_USING_UTILITY_LIB)...; ʾʵùܿ
#endif //end _GN_H_
